【BZOJ3939】[Usaco2015 Feb]Cow Hopscotch 动态规划+线段树

【BZOJ3939】[Usaco2015 Feb]Cow Hopscotch

Description

Just like humans enjoy playing the game of Hopscotch, Farmer John's cows have invented a variant of the game for themselves to play. Being played by clumsy animals weighing nearly a ton, Cow Hopscotch almost always ends in disaster, but this has surprisingly not deterred the cows from attempting to play nearly every afternoon.

The game is played on an R by C grid (2 <= R <= 750, 2 <= C <= 750), where each square is labeled with an integer in the range 1..K (1 <= K <= R*C). Cows start in the top-left square and move to the bottom-right square by a sequence of jumps, where a jump is valid if and only if

1) You are jumping to a square labeled with a different integer than your current square,

2) The square that you are jumping to is at least one row below the current square that you are on, and

3) The square that you are jumping to is at least one column to the right of the current square that you are on.

Please help the cows compute the number of different possible sequences of valid jumps that will take them from the top-left square to the bottom-right square.

就像人类喜欢跳格子游戏一样,FJ的奶牛们发明了一种新的跳格子游戏。虽然这种接近一吨的笨拙的动物玩跳格子游戏几乎总是不愉快地结束,但是这并没有阻止奶牛们在每天下午参加跳格子游戏 
游戏在一个R*C的网格上进行,每个格子有一个取值在1-k之间的整数标号,奶牛开始在左上角的格子,目的是通过若干次跳跃后到达右下角的格子,当且仅当格子A和格子B满足如下条件时能从格子A跳到格子B: 
1.B格子在A格子的严格右方(B的列号严格大于A的列号) 
2.B格子在A格子的严格下方(B的行号严格大于A的行号) 
3.B格子的标号和A格子的标号不同 
请你帮助奶牛计算出从左上角的格子到右下角的格子一共有多少种不同的方案

Input

The first line contains the integers R, C, and K. The next R lines will each contain C integers, each in the range 1..K.
第一行包含两个整数R C K 
接下来的R行,每行C个整数表示格子的标号

Output

Output the number of different ways one can jump from the top-left square to the bottom-right square, mod 1000000007.

一行,代表有多少种不同的方案,由于答案很大,请输出答案对1000000007取模的结果

Sample Input

4 4 4
1 1 1 1
1 3 2 1
1 2 4 1
1 1 1 1

Sample Output

5

题解:标号不同的方案数=总方案数 - 标号相同的方案数

总的方案数我们可以用前缀和轻松搞定,标号相同的方案数怎么搞?

(一开始想用树状数组,结果发现标号种类太多RE了)

所以我们只能采用动态开点线段树,对每种标号都开一棵线段树来维护前缀和就好了

#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define mod 1000000007
using namespace std;
int n,m,K,tot;
int map[800][800],f[800][800],sum[800];
struct Seg
{
	int ls,rs,cnt;
}s[6001000];
void updata(int l,int r,int &x,int y,int v)
{
	if(!x)	x=++tot;
	if(l==r)
	{
		s[x].cnt=(s[x].cnt+v)%mod;
		return ;
	}
	int mid=l+r>>1;
	if(y<=mid)	updata(l,mid,s[x].ls,y,v);
	else	updata(mid+1,r,s[x].rs,y,v);
	s[x].cnt=(s[s[x].ls].cnt+s[s[x].rs].cnt)%mod;
}
int query(int l,int r,int x,int y)
{
	if(!x)	return 0;
	if(r<=y)	return s[x].cnt;
	int mid=l+r>>1;
	if(y<=mid)	return query(l,mid,s[x].ls,y);
	return (query(l,mid,s[x].ls,y)+query(mid+1,r,s[x].rs,y))%mod;
}
int main()
{
	scanf("%d%d%d",&n,&m,&K);
	tot=K;
	int i,j,t;
	for(i=1;i<=n;i++)	for(j=1;j<=m;j++)	scanf("%d",&map[i][j]);
	f[1][1]=1;
	for(i=1;i<m;i++)	sum[i]=1;
	updata(1,m,map[1][1],1,1);
	for(i=2;i<n;i++)
	{
		for(j=2;j<m;j++)	f[i][j]=(sum[j-1]-query(1,m,map[i][j],j-1)+mod)%mod;
		t=0;
		for(j=2;j<m;j++)
		{
			t=(t+f[i][j])%mod;
			sum[j]=(sum[j]+t)%mod;
			updata(1,m,map[i][j],j,f[i][j]);
		}
	}
	printf("%d",(sum[m-1]-query(1,m,map[n][m],m-1)+mod)%mod);
	return 0;
}
posted @ 2017-02-18 16:57  CQzhangyu  阅读(697)  评论(0编辑  收藏  举报